// WARNING: generated by kopium - manual changes will be overwritten
// kopium command: kopium -f servicel2statuses.yml --schema=derived --docs -b --derive=Default --derive=PartialEq --smart-derive-elision
// kopium version: 0.21.1

#[allow(unused_imports)]
mod prelude {
    pub use kube_derive::CustomResource;
    #[cfg(feature = "schemars")]
    pub use schemars::JsonSchema;
    pub use serde::{Deserialize, Serialize};
    #[cfg(feature = "builder")]
    pub use typed_builder::TypedBuilder;
}
use self::prelude::*;

/// ServiceL2StatusSpec defines the desired state of ServiceL2Status.
#[derive(CustomResource, Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
#[cfg_attr(not(feature = "schemars"), kube(schema = "disabled"))]
#[kube(
    group = "metallb.io",
    version = "v1beta1",
    kind = "ServiceL2Status",
    plural = "servicel2statuses"
)]
#[kube(namespaced)]
#[kube(status = "ServiceL2StatusStatus")]
#[kube(derive = "Default")]
#[kube(derive = "PartialEq")]
pub struct ServiceL2StatusSpec {}

/// MetalLBServiceL2Status defines the observed state of ServiceL2Status.
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct ServiceL2StatusStatus {
    /// Interfaces indicates the interfaces that receive the directed traffic
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub interfaces: Option<Vec<ServiceL2StatusStatusInterfaces>>,
    /// Node indicates the node that receives the directed traffic
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub node: Option<String>,
    /// ServiceName indicates the service this status represents
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "serviceName"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub service_name: Option<String>,
    /// ServiceNamespace indicates the namespace of the service
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "serviceNamespace"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub service_namespace: Option<String>,
}

/// InterfaceInfo defines interface info of layer2 announcement.
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct ServiceL2StatusStatusInterfaces {
    /// Name the name of network interface card
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub name: Option<String>,
}
